protocols / TimestampingProtocol

# TimestampingProtocol

`class TimestampingProtocol : ProtocolLogic<LegallyIdentifiable>`

The TimestampingProtocol class is the client code that talks to a NodeTimestamperService on some remote node. It is a ProtocolLogic, meaning it can either be a sub-protocol of some other protocol, or be driven independently.

If you are not yourself authoring a protocol and want to timestamp something, the TimestampingProtocol.Client class implements the TimestamperService interface, meaning it can be passed to TransactionBuilder.timestamp to timestamp the built transaction. Please be aware that this will block, meaning it should not be used on a thread that is handling a network message: use it only from spare application threads that dont have to respond to anything.

### Types

Client | `class Client : TimestamperService`
REQUESTING | `object REQUESTING : Step`
Request | `class Request : AbstractRequestMessage`
VALIDATING | `object VALIDATING : Step`

### Constructors

<init> | `TimestampingProtocol(node: NodeInfo, wtxBytes: SerializedBytes<WireTransaction>, progressTracker: ProgressTracker = TimestampingProtocol.tracker())` The TimestampingProtocol class is the client code that talks to a NodeTimestamperService on some remote node. It is a ProtocolLogic, meaning it can either be a sub-protocol of some other protocol, or be driven independently.

### Properties

progressTracker | `val progressTracker: ProgressTracker` Override this to provide a ProgressTracker. If one is provided and stepped, the framework will do something helpful with the progress reports. If this protocol is invoked as a sub-protocol of another, then the tracker will be made a child of the current step in the parent. If its null, this protocol doesnt track progress.

### Inherited Properties

logger | `val logger: <ERROR CLASS>` This is where you should log things to.
psm | `lateinit var psm: ProtocolStateMachine<*>` Reference to the Fiber instance that is the top level controller for the entire flow.
serviceHub | `val serviceHub: ServiceHub` Provides access to big, heavy classes that may be reconstructed from time to time, e.g. across restarts

### Functions

call | `fun call(): LegallyIdentifiable` This is where you fill out your business logic.

### Inherited Functions

receive | `fun <T : Any> receive(topic: String, sessionIDForReceive: Long): UntrustworthyData<T>` `fun <T : Any> receive(topic: String, sessionIDForReceive: Long, clazz: Class<T>): UntrustworthyData<T>`
send | `fun send(topic: String, destination: MessageRecipients, sessionID: Long, obj: Any): Unit`
sendAndReceive | `fun <T : Any> sendAndReceive(topic: String, destination: MessageRecipients, sessionIDForSend: Long, sessionIDForReceive: Long, obj: Any): UntrustworthyData<T>`
subProtocol | `fun <R> subProtocol(subLogic: ProtocolLogic<R>): R` Invokes the given subprotocol by simply passing through this ProtocolLogics reference to the ProtocolStateMachine and then calling the call method.

### Companion Object Functions

tracker | `fun tracker(): ProgressTracker`